;
;*******************************************************
;*******************************************************
;**                                                   **
;**    Sztuka programowania mikrokontrolerow AVR      **
;**                                                   **
;**       Prezentacje i ilustracje algorytmow         **
;**                                                   **
;**       Andrzej Pawluczuk                           **
;**                                                   **
;**         Mikrokontroler: ATMEGA8515                **
;**                Bialystok, 2006                    **
;**                                                   **
;*******************************************************
;*******************************************************
;
;*******************************************************
.include "m8515def.inc"
;*******************************************************
		.list
		.listmac
;-----------------------------------------------------------------------------
.macro	ldz
	ldi	zl,low(@0)
	ldi	zh,high(@0)
.endm
;-----------------------------------------------------------------------------
.macro	ldx
	ldi	xl,low(@0)
	ldi	xh,high(@0)
.endm
;-----------------------------------------------------------------------------
.macro	pushz
	push	zl
	push	zh
.endm
;-----------------------------------------------------------------------------
.macro	popz
	pop	zh
	pop	zl
.endm
;-----------------------------------------------------------------------------
.macro	pushf
	push	acc
	in	acc,sreg
	push	acc
.endm
;-----------------------------------------------------------------------------
.macro	popf
	pop	acc
	out	sreg,acc
	pop	acc
.endm
;-----------------------------------------------------------------------------
.def Arg1L		= r2
.def Arg1H		= r3
.def ResultL		= r6
.def ResultH		= r7
.def acc		= r16
.def acc2		= r17
.def param		= r18
;-----------------------------------------------------------------------------
		.dseg
;*******************************************************
;*******************************************************
;**                                                   **
;**                  DATA  SEGMENT                    **
;**                                                   **
;*******************************************************
;*******************************************************
;-----------------------------------------------------------------------------
		.cseg
;*******************************************************
;*******************************************************
;**                                                   **
;**                  CODE  SEGMENT                    **
;**                                                   **
;*******************************************************
;*******************************************************
	.org	0				;
	rjmp	ResetProcessor			;
;-----------------------------------------------------------------------------
Relacje16 :			;
				; badanie warunku r17:r16 = r19:r18
	ldi	r16 , 0x12	; pobranie do rejestru r16 sta (jako
				; cz modsz)
	ldi	r17 , 0x34	; pobranie do rejestru r17 sta (jako
				; cz starsz)
				; w wyniku para rejestrw
				; r17:r16=3412 hex (13330 dec)
	ldi	r18 , 0x12	; pobranie do rejestru r18 sta (jako
				; cz modsz)
	ldi	r19 , 0x34	; pobranie do rejestru r19 sta (jako
				; cz starsz)
				; w wyniku para rejestrw
				; r19:r18=3412 hex (13330 dec)
				; obie liczby do porwnania s identyczne
	cp	r16 , r18	; porwnanie najmodszych czci liczby
				; w wyniku dziaania instrukcji
				; wskanik Z=1
	cpc	r17 , r19	; porwnanie starszych czci liczby
				; w wyniku dziaania instrukcji
				; wskanik Z=1
				; ustawiony wskanik Z oznacza, e
				; liczby s rwne
;-----------------------------------
	ldi	r16 , 0x11	; pobranie do rejestru r16 sta (jako
				; cz modsz)
	ldi	r17 , 0x34	; pobranie do rejestru r17 sta (jako
				; cz starsz)
				; w wyniku para rejestrw
				; r17:r16=3411 hex (13329 dec)
	ldi	r18 , 0x12	; pobranie do rejestru r18 sta (jako
				; cz modsz)
	ldi	r19 , 0x34	; pobranie do rejestru r19 sta (jako
				; cz starsz)
				; w wyniku para rejestrw
				; r19:r18=3412 hex (13330 dec)
	cp	r16 , r18	; porwnanie najmodszych czci liczby
				; w wyniku dziaania instrukcji
				; wskanik Z=0 oraz wskanik C=1
	cpc	r17 , r19	; porwnanie starszych czci liczby
				; w wyniku dziaania instrukcji
				; wskanik Z=0 (pomimo, e
				; zawarto porwnywanych rejestrw jest
				; identyczna) oraz wskanik C=1
				; wyzerowany wskanik Z oznacza, e
				; liczby nie s rwne
				; ustawiony wskanik C oznacza, e para
				; rejestrw r17:r16 zawiera liczb
				; mniejsz ni para rejestrw r19:r18
;-----------------------------------
	ldi	r16 , 0x13	; pobranie do rejestru r16 sta (jako
				; cz modsz)
	ldi	r17 , 0x34	; pobranie do rejestru r17 sta (jako
				; cz starsz)
				; w wyniku para rejestrw
				; r17:r16=3413 hex (13331 dec)
	ldi	r18 , 0x12	; pobranie do rejestru r18 sta (jako
				; cz modsz)
	ldi	r19 , 0x34	; pobranie do rejestru r19 sta (jako
				; cz starsz)
				; w wyniku para rejestrw
				; r19:r18=3412 hex (13330 dec)
	cp	r16 , r18	; porwnanie najmodszych czci liczby
				; w wyniku dziaania instrukcji
				; wskanik Z=0 oraz wskanik C=0
	cpc	r17 , r19	; porwnanie starszych czci liczby
				; w wyniku dziaania instrukcji
				; wskanik Z=0 oraz wskanik C=0
				; wyzerowany wskanik Z oznacza,
				; e liczby nie s rwne
				; wyzerowany wskanik C oznacza, e para
				; rejestrw r17:r16 zawiera liczb
				; wiksz lub rowna co para rejestrw r19:r18
	ret			;
;-----------------------------------------------------------------------------
Relacje16U2 :			;
	ldi	r16,0xF6	; pobranie do rejestru r16 sta (jako cz
				; modsz)
	ldi	r17,0xFF	; pobranie do rejestru r17 sta (jako cz
				; starsz)
				; w wyniku para rejestrw r17:r16=FFF6 hex
				; w kodzie U2=-10 dec
	ldi	r18,0x0A	; pobranie do rejestru r18 sta (jako cz
				; modsz)
	ldi	r19,0x00	; pobranie do rejestru r19 sta (jako cz
				; starsz)
				; w wyniku para rejestrw r19:r18=00A0 hex
				; w kodzie U2=+10 dec
	cp	r16,r18		; porwnanie czci modszych, w wyniku
				; dziaania instrukcji wskaniki przyjmuj
				; warto: Z=0, S=1
	cpc	r17,r19		; porwnanie czci starszych, w wyniku
				; otrzymujemy: Z=0, S=1 co oznacza, e liczby
				; nie s rwne (Z=0) oraz
				; ich rnica jest ujemna (S=1)
				; [r17:r16  r19:r18 < 0]
				; to znaczy, e  r17:r16 < r19:r18,
				; w istocie: -10 < +10
;----------------------------------
	ldi	r16,0x0A	; pobranie do rejestru r16 sta (jako cz
				; modsz)
	ldi	r17,0x00	; pobranie do rejestru r17 sta (jako cz
				; starsz)
				; w wyniku para rejestrw r17:r16=00A0 hex
				; w kodzie U2=+10 dec
	ldi	r18,0xF6	; pobranie do rejestru r18 sta (jako cz
				; modsz)
	ldi	r19,0xFF	; pobranie do rejestru r19 sta (jako cz
				; starsz)
				; w wyniku para rejestrw r19:r18=FFF6 hex
				; w kodzie U2=-10 dec
	cp	r16,r18		; porwnanie czci modszych, w wyniku
				; dziaania instrukcji wskaniki przyjmuj
				; warto: Z=0, S=0
	cpc	r17,r19		; porwnanie czci starszych, w wyniku
				; otrzymujemy: Z=0, S=0 co oznacza, e liczby
				; nie s rwne (Z=0) oraz
				; ich rnica nie jest ujemna (S=0)
				; [r17:r16  r19:r18 > 0]
				; to znaczy, e  r17:r16 > r19:r18,
				; w istocie: +10 > -10
;----------------------------------
	ldi	r16,0xEC	; pobranie do rejestru r16 sta (jako cz
				; modsz)
	ldi	r17,0xFF	; pobranie do rejestru r17 sta (jako cz
				; starsz)
				; w wyniku para rejestrw r17:r16=FFEC hex
				; w kodzie U2=-20 dec
	ldi	r18,0xF6	; pobranie do rejestru r18 sta (jako cz
				; modsz)
	ldi	r19,0xFF	; pobranie do rejestru r19 sta (jako cz
				; starsz)
				; w wyniku para rejestrw r19:r18=FFF6 hex
				; w kodzie U2=-10 dec
	cp	r16,r18		; porwnanie czci modszych, w wyniku
				; dziaania instrukcji wskaniki przyjmuj
				; warto: Z=0, S=1
	cpc	r17,r19		; porwnanie czci starszych, w wyniku
				; otrzymujemy: Z=0, S=1 co oznacza,
				; e liczby nie s rwne (Z=0) oraz
				; ich rnica jest ujemna (S=1)
				; [r17:r16  r19:r18 < 0]
				; to znaczy, e  r17:r16 < r19:r18,
				; w istocie: -20 < -10
;----------------------------------
	ldi	r16,0xFB	; pobranie do rejestru r16 sta (jako cz
				; modsz)
	ldi	r17,0xFF	; pobranie do rejestru r17 sta (jako cz
				; starsz)
				; w wyniku para rejestrw r17:r16=FFFB hex
				; w kodzie U2=-5 dec
	ldi	r18,0xF6	; pobranie do rejestru r18 sta (jako cz
				; modsz)
	ldi	r19,0xFF	; pobranie do rejestru r19 sta (jako cz
				; starsz)
				; w wyniku para rejestrw r19:r18=FFF6 hex
				; w kodzie U2=-10 dec
	cp	r16,r18		; porwnanie czci modszych, w wyniku
				; dziaania instrukcji wskaniki przyjmuj
				; warto: Z=0, S=0
	cpc	r17,r19		; porwnanie czci starszych, w wyniku
				; otrzymujemy: Z=0, S=0 co oznacza,
				; e liczby nie s rwne (Z=0) oraz
				; ich rnica nie jest ujemna (S=0)
				; [r17:r16  r19:r18 > 0]
				; to znaczy, e  r17:r16 > r19:r18,
				; w istocie: -5 > -10
	ret			;
;-----------------------------------------------------------------------------
RelacjeU2 :			;
	ldi	r16 , 0xF4	; r16 zawiera warto = F4 hex
				;                     = -12 dec (kod U2)
	ldi	r17 , 0xF5	; r17 zawiera warto = F5 hex
				;                     = -11 dec (kod U2)
				; warunek: czy r16 < r17
				;(czy (-12) < (-11))?
	cp	r16 , r17	; operacja porwnania (obliczenie rnicy
				; r16-r17 i zachowanie jedynie
				; wskanikw) jeeli rnica zawartoci
				; rejestrw r16 i r17
				; jest ujemna, to zostanie ustawiony
				; wskanik S, tu S=1
	brlt	U2etykieta1	; nastpi skok do etykiety 'U2etykieta1
				; (skok przy spenionym warunku S=1)
	ldi	acc,0		;
U2etykieta1 :			;
	ldi	acc,1		;
;------------------------------------------
	ldi	r16 , 0xF4	; r16 zawiera warto = F4 hex
				;                     = -12 dec (kod U2)
	ldi	r17 , 0x45	; r17 zawiera warto = 45 hex
				;                     = 69 dec (kod U2)
				; warunek: czy r16 < r17
				; (czy (-12) < 69)?
	cp	r16 , r17	; operacja porwnania,  tu S=1
	brlt	U2etykieta2	; nastpi skok do etykiety U2etykieta2
				; (skok przy spenionym warunku S=1)
	ldi	acc,0		;
U2etykieta2 :			;
	ldi	acc,1		;
;------------------------------------------
	ldi	r16 , 0xF4	; r16 zawiera warto = F4 hex
				;                     = -12 dec (kod U2)
	ldi	r17 , 0xF5	; r17 zawiera warto = F5 hex
				;                     = -11 dec (kod U2)
				; warunek: czy r16 > r17
				; (czy (-12) > (-11))?
	cp	r17 , r16	; operacja porwnania (z argumentami
				; zamienionymi miejscami), tu S=0
	brlt	U2etykieta3	; nie nastpi skok do etykiety U2etykieta3
				; (skok przy spenionym warunku S=1)
	ldi	acc,0		;
U2etykieta3 :			;
	ldi	acc,1		;
;------------------------------------------
	ldi	r16 , 0xF4	; r16 zawiera warto = F4 hex
				;                     = -12 dec (kod U2)
	ldi	r17 , 0x45	; r17 zawiera warto = 45 hex
				;                     = 69 dec (kod U2)
				; warunek: czy r16 > r17
				; (czy (-12) > 69)?
	cp	r17 , r16	; operacja porwnania, tu S=0
	brlt	U2etykieta4	; nie nastpi skok do etykiety U2etykieta4
				; (skok przy spenionym warunku S=1)
	ldi	acc,0		;
U2etykieta4 :			;
	ldi	acc,1		;
;------------------------------------------
	ldi	r16 , 0x45	; r16 zawiera warto = 45 hex
				;                     = 69 dec (kod U2)
	ldi	r17 , 0xFF	; r17 zawiera warto = FF hex
				;                     = -1 dec (kod U2)
				; warunek: czy r16 > r17 (czy 69 > (-1))?
	cp	r17 , r16	; operacja porwnania, tu S=1
	brlt	U2etykieta5	; nastpi skok do etykiety U2etykieta5
				; (skok przy spenionym warunku S=1)
	ldi	acc,0		;
U2etykieta5 :			;
	ldi	acc,1		;
;------------------------------------------
	ldi	r16 , 0xF4	; r16 zawiera warto = F4 hex
				;                     = -12 dec (kod U2)
	ldi	r17 , 0xF5	; r17 zawiera warto = F5 hex
				;                     = -11 dec (kod U2)
				; warunek: czy r16 <= r17
				; (czy (-12) <= (-11) ) ?
	cp	r17 , r16	; operacja porwnania, tu S=0
	brge	U2etykieta6	; nastpi skok do etykiety
				; U2etykieta6 (skok przy
				; spenionym warunku S=0)
	ldi	acc,0		;
U2etykieta6 :			;
	ldi	acc,1		;
;------------------------------------------
	ldi	r16 , 0xF4	; r16 zawiera warto = F4 hex
				;                     = -12 dec (kod U2)
	ldi	r17 , 0x45	; r17 zawiera warto = 45 hex
				;                     = 69 dec (kod U2)
				; warunek: czy r16 <= r17
				; (czy (-12) <= 69)?
	cp	r17 , r16	; operacja porwnania, tu S=0
	brge	U2etykieta7	; nastpi skok do etykiety
				; U2etykieta7 (skok przy
				; spenionym warunku S=0)
	ldi	acc,0		;
U2etykieta7 :			;
	ldi	acc,1		;
;------------------------------------------
	ldi	r16 , 0x45	; r16 zawiera warto = 45 hex
				;                     = 69 dec (kod U2)
	ldi	r17 , 0xFF	; r17 zawiera warto = FF hex
				;                     = -1 dec (kod U2)
				; warunek: czy r16 <= r17 (czy 69 <= (-1))?
	cp	r17 , r16	; operacja porwnania, tu S=1
	brge	U2etykieta8	; nie nastpi skok do etykiety
				; U2etykieta8 (skok
				; przy spenionym warunku S=0)
	ldi	acc,0		;
U2etykieta8 :			;
	ldi	acc,1		;
;------------------------------------------
	ldi	r16 , 0xF4	; r16 zawiera warto = F4 hex
				;                     = -12 dec (kod U2)
	ldi	r17 , 0xF5	; r17 zawiera warto = F5 hex
				;                     = -11 dec (kod U2)
				; warunek: czy r16 >= r17
				; (czy (-12) >= (-11) ) ?
	cp	r16 , r17	; operacja porwnania, tu S=1
	brge	U2etykieta9	; nie nastpi skok do etykiety
				; U2etykieta9 (skok
				; przy spenionym warunku S=0)
	ldi	acc,0		;
U2etykieta9 :			;
	ldi	acc,1		;
;------------------------------------------
	ldi	r16 , 0xF4	; r16 zawiera warto = F4 hex
				;                     = -12 dec (kod U2)
	ldi	r17 , 0x45	; r17 zawiera warto = 45 hex
				;                     = 69 dec (kod U2)
				; warunek: czy r16 >= r17
				; (czy (-12) >= 69)?
	cp	r16 , r17	; operacja porwnania, tu S=1
	brge	U2etykieta10	; nie nastpi skok do etykiety
				; U2etykieta10(skok
				; przy spenionym warunku S=0)
	ldi	acc,0		;
U2etykieta10 :			;
	ldi	acc,1		;
;------------------------------------------
	ldi	r16 , 0x45	; r16 zawiera warto = 45 hex
				;                     = 69 dec (kod U2)
	ldi	r17 , 0xFF	; r17 zawiera warto = FF hex
				;                     = -1 dec (kod U2)
				; warunek: czy r16 >= r17 (czy 69 >= (-1))?
	cp	r16 , r17	; operacja porwnania, tu S=0
	brge	U2etykieta11	; nastpi skok do etykiety
				; U2etykieta11 (skok
				; przy spenionym warunku S=0)
	ldi	acc,0		;
U2etykieta11 :			;
	ldi	acc,1		;
	ret			;
;-----------------------------------------------------------------------------
Relacje :			;
	ldi	r16 , 0x44	; r16 zawiera warto = 44 hex
				;                     = 68 dec (kod NB)
	ldi	r17 , 0x44	; r17 zawiera warto = 44 hex
				;                     = 68 dec (kod NB)
				; warunek: czy r16 = r17 (czy 68 = 68)?
	cp	r16 , r17	; operacja porwnania (obliczenie rnicy
				; r16-r17 i zachowanie jedynie
				; wskanikw) w tym przypadku wskanik
				; Z=1
	breq	etykieta1	; jeeli zawarto rejestrw jest
				; identyczna to nastpi skok do etykiety
				; etykieta1 (skok jeeli wskanik Z=1)
				; w tym przypadku nastpi skok do
				; etykiety
	ldi	acc,0		;
etykieta1 :			;
	ldi	acc,1		;
;---------------------------
	ldi	r16 , 0xF4	; r16 zawiera warto = F4 hex
				;                     = -12 dec (kod U2)
	ldi	r17 , 0xF5	; r17 zawiera warto = F5 hex
				;                     = -11 dec (kod U2)
				; warunek: czy r16=r17
				; (czy (-12) = (-11))?
	cp	r16 , r17	; operacja porwnania, tutaj wskanik Z=0
	breq	etykieta2	; w tym przypadku nie nastpi skok do
				; etykiety, wykonanie programu w
				; naturalny sposb
				; przejdzie do nastpnej instrukcji
	ldi	acc,0		;
etykieta2 :			;
	ldi	acc,1		;
;---------------------------
	ldi	r16 , 0x44	; r16 zawiera warto = 44 hex
				;                     = 68 dec (kod NB)
	ldi	r17 , 0x44	; r17 zawiera warto = 44 hex
				;                     = 68 dec (kod NB)
				; warunek: czy r16 # r17 (czy 68 # 68)?
	cp	r16 , r17	; operacja porwnania (obliczenie rnicy
				; r16-r17 i zachowanie jedynie
				; wskanikw) w tym przypadku wskanik
				; Z=1
	brne	etykieta3	; w tym przypadku nie nastpi skok do
				; etykiety, (skok jeeli wskanik Z=0)
				; wykonanie programu w naturalny sposb
				; przejdzie do nastpnej instrukcji
	ldi	acc,0		;
etykieta3 :			;
	ldi	acc,1		;
;---------------------------
	ldi	r16 , 0xF4	; r16 zawiera warto = F4 hex
				;                     = -12 dec (kod U2)
	ldi	r17 , 0xF5	; r17 zawiera warto = F5 hex
				;                     = -11 dec (kod U2)
				; warunek: czy r16 # r17
				; (czy (-12) # (-11))?
	cp	r16 , r17	; operacja porwnania (obliczenie rnicy
				; r16-r17 i zachowanie jedynie
				; wskanikw) w tym przypadku wskanik
				; Z=0
	brne	etykieta4	; w tym przypadku nastpi skok do
				; etykiety 'etykieta4'
	ldi	acc,0		;
etykieta4 :			;
	ldi	acc,1		;
;---------------------------
	ldi	r16 , 0x44	; r16 zawiera warto = 44 hex
				;                     = 68 dec (kod NB)
	ldi	r17 , 0x45	; r17 zawiera warto = 45 hex
				;                     = 69 dec (kod NB)
				; warunek: czy r16 < r17 (czy 68 < 69)?
	cp	r16 , r17	; operacja porwnania (obliczenie rnicy
				; r16-r17 i zachowanie jedynie
				; wskanikw) jeeli zawarto rejestru
				; r16 jest mniejsza od zawartoci
				; rejestru r17, to zostanie ustawiony
				; wskanik C (poyczka,
				; bo 44 hex  45 hex<0), tu C=1
	brcs	etykieta5	; nastpi skok do etykiety etykieta5
				; (C=1)
	ldi	acc,0		;
etykieta5 :			;
	ldi	acc,1		;
;------------------------------------------
	ldi	r16 , 0x54	; r16 zawiera warto = 54 hex
				;                     = 84 dec (kod NB)
	ldi	r17 , 0x45	; r17 zawiera warto = 45 hex
				;                     = 69 dec (kod NB)
				; warunek: czy r16 < r17 (czy 84 < 69)?
	cp	r16 , r17	; operacja porwnania (obliczenie rnicy
				; r16-r17 i zachowanie jedynie
				; wskanikw) jeeli zawarto rejestru
				; r16 jest mniejsza od zawartoci
				; rejestru r17, to zostanie ustawiony
				; wskanik C (poyczka), tu C=0
	brcs	etykieta6	; nie nastpi skok do etykiety etykieta6
				; (C=0)
	ldi	acc,0		;
etykieta6 :			;
	ldi	acc,1		;
;------------------------------------------
	ldi	r16 , 0x44	; r16 zawiera warto = 44 hex
				;                     = 68 dec (kod NB)
	ldi	r17 , 0x45	; r17 zawiera warto = 45 hex
				;                     = 69 dec (kod NB)
				; warunek: czy r16 > r17 (czy 68 > 69)?
	cp	r17 , r16	; operacja porwnania (obliczenie rnicy
				; r17-r16 i zachowanie jedynie
				; wskanikw), nie zostanie ustawiony
				; wskanik C 
				;(bo 45 hex(r17)  44 hex (r16) > 0)
				; tu C=0
	brcs	etykieta7	; tu nie nastpi skok do etykiety
				; etykieta7
	ldi	acc,0		;
etykieta7 :			;
	ldi	acc,1		;
;------------------------------------------
	ldi	r16 , 0x54	; r16 zawiera warto = 54 hex
				;                     = 84 dec (kod NB)
	ldi	r17 , 0x45	; r17 zawiera warto = 45 hex
				;                     = 69 dec (kod NB)
				; warunek: czy r16 > r17 (czy 84 > 69)?
	cp	r17 , r16	; operacja porwnania (obliczenie rnicy
				; r17-r16 i zachowanie jedynie
				; wskanikw) tu zostanie ustawiony
				; wskanik C=1 (poyczka)
	brcs	etykieta8	; nastpi skok do etykiety etykieta8
	ldi	acc,0		;
etykieta8 :			;
	ldi	acc,1		;
;------------------------------------------
	ldi	r16 , 0x44	; r16 zawiera warto = 44 hex
				;                     = 68 dec (kod NB)
	ldi	r17 , 0x45	; r17 zawiera warto = 45 hex
				;                     = 69 dec (kod NB)
				; warunek: czy r16 <= r17 (czy 68 <= 69)?
	cp	r17 , r16	; operacja porwnania (obliczenie rnicy
				; r17-r16 i zachowanie jedynie
				; wskanikw) nie zostanie ustawiony
				; wskanik C (poyczka, C=0)
	brcc	etykieta9	; tu nastpi skok do etykiety
				; etykieta9
	ldi	acc,0		;
etykieta9 :			;
	ldi	acc,1		;
;------------------------------------------
	ldi	r16 , 0x54	; r16 zawiera warto = 54 hex
				;                     = 84 dec (kod NB)
	ldi	r17 , 0x45	; r17 zawiera warto = 45 hex
				;                     = 69 dec (kod NB)
				; warunek: czy r16 <= r17 (czy 84 <= 69)?
	cp	r17 , r16	; operacja porwnania (obliczenie rnicy
				; r17-r16 i zachowanie jedynie
				; wskanikw) jeeli zawarto rejestru
				; r17 jest mniejsza od
				; zawartoci rejestru r16, to zostanie
				; ustawiony wskanik C (poyczka), tu C=1
	brcc	etykieta10	; nie nastpi skok do etykiety
				; etykieta10
	ldi	acc,0		;
etykieta10 :			;
	ldi	acc,1		;
;------------------------------------------
	ldi	r16 , 0x44	; r16 zawiera warto = 44 hex
				;                     = 68 dec (kod NB)
	ldi	r17 , 0x45	; r17 zawiera warto = 45 hex
				;                     = 69 dec (kod NB)
				; warunek r16 >= r17 (czy 68 >= 69)?
	cp	r16 , r17	; operacja porwnania (obliczenie rnicy
				; r16-r17 i zachowanie jedynie
				; wskanikw) zostanie ustawiony wskanik
				; C (poyczka), tu C=1
	brcc	etykieta11	; nie nastpi skok do etykiety
				; etykieta11
	ldi	acc,0		;
etykieta11 :			;
	ldi	acc,1		;
;------------------------------------------
	ldi	r16 , 0x54	; r16 zawiera warto = 54 hex
				;                     = 84 dec (kod NB)
	ldi	r17 , 0x45	; r17 zawiera warto = 45 hex
				;                     = 69 dec (kod NB)
				; warunek r16 >= r17 (czy 84 >= 69)?
	cp	r16 , r17	; operacja porwnania (obliczenie rnicy
				; r16-r17 i zachowanie jedynie
				; wskanikw) nie zostanie ustawiony
				; wskanik C (poyczka), tu C=0
	brcc	etykieta12	; nastpi skok do etykiety
				; etykieta12
	ldi	acc,0		;
etykieta12 :			;
	ldi	acc,1		;
	ret
;-----------------------------------------------------------------------------
DivBy10:			;FUNCTION DivBy10 ( ARG1 : WORD ) : WORD ;
;************
				; Result := Arg1 / 10 ;
				; Result=ResultH:ResultL
				; Arg1=Arg1H:Arg1L
				; s sowami (po 2 bajty)
	mov	ResultL,Arg1L	; skadnik wchodzcy z wag 1
	mov	ResultH,Arg1H	; (pierwszy wpis do rejestru
				; wynikowego)
	rcall	Shift2		; podzia argumentu przez 4
				; (przesunicie o 2 bity)
	sub	ResultL,Arg1L	; skadnik wchodzcy z wag -1/4
	sbc	ResultH,Arg1H	;
	rcall	Shift2		; podzia argumentu przez 4
				; (przesunicie o 2 bity)
	add	ResultL,Arg1L	; skadnik wchodzcy z wag 1/16
	adc	ResultH,Arg1H	;
	rcall	Shift2		; podzia argumentu przez 4
				; (przesunicie o 2 bity)
	sub	ResultL,Arg1L	; skadnik wchodzcy z wag -1/64
	sbc	ResultH,Arg1H	;
	rcall	Shift2		; podzia argumentu przez 4
				; (przesunicie o 2 bity)
	add	ResultL,Arg1L	; skadnik wchodzcy z wag 1/256
	adc	ResultH,Arg1H	;
	rcall	Shift2		; podzia argumentu przez 4
				; (przesunicie o 2 bity)
	sub	ResultL,Arg1L	; skadnik wchodzcy z wag -1/1024
	sbc	ResultH,Arg1H	;
	rcall	Shift2		; podzia argumentu przez 4
				; (przesunicie o 2 bity)
	add	ResultL,Arg1L	; skadnik wchodzcy z wag 1/4096
	adc	ResultH,Arg1H	;
	rcall	Shift2		; podzia argumentu przez 4
				; (przesunicie o 2 bity)
	sub	ResultL,Arg1L	; skadnik wchodzcy z wag -1/16384
	sbc	ResultH,Arg1H	;
	lsr	ResultH		; kocowy podzia wyniku przez 8
				; (przesunicie o 3 bity)
	ror	ResultL		;
	lsr	ResultH		;
	ror	ResultL		;
	lsr	ResultH		;
	ror	ResultL		;
	ret			;
Shift2	:			; pomocnicza procedura do
				; przesuwania sowa o 2 bity
	lsr	Arg1H		;
	ror	Arg1L		;
	lsr	Arg1H		;
	ror	Arg1L		;
	ret			;END (* DivBy10 *) ;
;-----------------------------------------------------------------------------
DivBy10U2:			;FUNCTION DivBy10U2 ( ARG1 : INTEGER )
;				;				: INTEGER ;
;************			; Result := Arg1 / 10 ;
				; Result=ResultH:ResultL
				; Arg1=Arg1H:Arg1L
				; s sowami (po 2 bajty) zapisanymi w
				; kodzie U2
	mov	ResultL,Arg1L	; 1
	mov	ResultH,Arg1H	;
	rcall	Shift2U2	;
	sub	ResultL,Arg1L	; -1/4
	sbc	ResultH,Arg1H	;
	rcall	Shift2U2	;
	add	ResultL,Arg1L	; 1/16
	adc	ResultH,Arg1H	;
	rcall	Shift2U2	;
	sub	ResultL,Arg1L	; -1/64
	sbc	ResultH,Arg1H	;
	rcall	Shift2U2	;
	add	ResultL,Arg1L	; 1/256
	adc	ResultH,Arg1H	;
	rcall	Shift2U2	;
	sub	ResultL,Arg1L	; -1/1024
	sbc	ResultH,Arg1H	;
	rcall	Shift2U2	;
	add	ResultL,Arg1L	; 1/4096
	adc	ResultH,Arg1H	;
	rcall	Shift2U2	;
	sub	ResultL,Arg1L	; -1/16384
	sbc	ResultH,Arg1H	;
	asr	ResultH		; para instrukcji asr i ror
				; pozwala na dziaania na
	ror	ResultL		; liczbach zapisanych w kodzie U2
	asr	ResultH		; j.w.
	ror	ResultL		;
	asr	ResultH		; j.w.
	ror	ResultL		;
	ret			;	
Shift2U2:			;
	asr	Arg1H		; j.w.
	ror	Arg1L		;
	asr	Arg1H		; j.w.
	ror	Arg1L		;
	ret			;END (* DivBy10U2 *) ;
;-----------------------------------------------------------------------------
DzieleniePrzez10:		;
	ldi	acc,0x89	;
	mov	Arg1H,acc	;
	ldi	acc,0xAB	;
	mov	Arg1L,acc	; Wpis do rejestru Arg1 (Arg1H:Arg1L)
				; Arg1=89AB hex = 35243 dec (NB)
	rcall	DivBy10		; Dzielenie zawartosci rejestru Arg1
				; W wyniku Result (ResultH:ResultL) zawiera
	mov	acc,ResultH	; acc=0D hex
	mov	acc,ResultL	; acc=C4 hex
				; w sumie Result=0DC4 hex = 3524 dec
;*******
	ldi	acc,0xC1	;
	mov	Arg1H,acc	;
	ldi	acc,0xB2	;
	mov	Arg1L,acc	; Wpis do rejestru Arg1 (Arg1H:Arg1L)
				; Arg1 = C1B2 hex = -15950 dec (U2)
	rcall	DivBy10U2	; Dzielenie (ze znakiem) zawartosci rejestru
				; W wyniku Result (ResultH:ResultL) zawiera
	mov	acc,ResultH	; acc=F9 hex
	mov	acc,ResultL	; acc=C5 hex
				; w sumie Result=F9C5 hex = -1595 dec
	ret			;
;-----------------------------------------------------------------------------
DzieleniePrzez2:		;
	ldi	r16 , 0xA5	; r16 po wykonaniu zawiera: r16=A5 hex
	lsr	r16		; r16 po wykonaniu zawiera: r16=52 hex
				; C=1 (reszta z dzielenia jest rwna 1)
;*******
	ldi	r16,0xCD	; r16 = CD hex
	ldi	r17,0xAB	; r17 = AB hex
				; rejestr r17:r16 = ABCD hex = 43981 dec (NB)
	lsr	r17		; r17 = 55 hex
				; na pozycj bitu r17.7 wchodzi 0
				; natomiast wskanik C=r17.0 (tu C=1)
;*******
	ror	r16		; r16 = E6 hex
				; na pozycj bitu r16.7 wchodzi C=r17.0 (C=1)
				; rejestr r17:r16 = 55E6 hex = 21990 dec (NB)
				; wskanik C=1 (reszta z dzielenia=1)
	ldi	r16,0xA5	; r16 po wykonaniu zawiera: r16=A5 hex
				;		= -91 dec (U2)
	asr	r16		; r16 po wykonaniu zawiera: r16=D2 hex
				;		= -46 dec (U2)
				; C=1 (reszta z dzielenia jest rwna 1)
				; 2 * (-46) + 1 = -91
	ret			;
;-----------------------------------------------------------------------------
MnozeniePrzez2:			;
	ldi	r16,0x5A	; r16 po wykonaniu instrukcji ldi zawiera:
				; r16=5A hex=90 dec
	lsl	r16		; r16 po wykonaniu instrukcji lsl zawiera:
				; r16=B4 hex=180 dec
				; 2 * 5A hex = B4 hex
;*******
	ldi	r16,0x5A	; r16=5A hex= 90 dec (bez znaku i ze znakiem)
	lsl	r16		; r16=B4 hex
				;		= 180 dec (w kodzie NB)
				;		= -76 dec (w kodzie U2)
				; wskanik C=0
				; wskanik V=1
				; nastpi nadmiar operacji w kodzie U2,
				; poniewa po wykonaniu operacji wynik
				; 'prbuje zmieni znak'
				; tj. zmianie ulega stan najstarszego bitu.
;*******
	ldi	r16,0x34	; r16 = 34 hex
	ldi	r17,0x12	; r17 = 12 hex
				; rejestr r17:r16 = 1234 hex
				;		= 4660 dec (w kodzie U2)
				; 		= 4660 dec (w kodzie NB)
	lsl	r16		; r16 = 68 hex
				; na pozycj bitu r16.0 wchodzi 0
				; natomiast wskanik C=r16.7 (tu C=0)
	rol	r17		; r17 = 24 hex
				; na pozycj bitu r17.0 wchodzi C=r16.7 (C=0)
				; po operacji: wskanik V=0, wskanik C=0
				; wynik jest poprawny zarwno w kodzie NB i U2
				; po wykonaniu operacji rejestr
				; r17:r16 = 2468 hex
				;		= 9320 dec (w kodzie U2)
				; 		= 9320 dec (w kodzie NB).
;*******
	ldi	r16,0xDC	; r16 = 65 hex
	ldi	r17,0xFE	; r17 = 87 hex
				; rejestr r17:r16 = FEDC hex
				;		= -292 dec (w kodzie U2)
				; 		= 65244 dec (w kodzie NB)
	lsl	r16		; r16 = B8 hex
				; na pozycj bitu r16.0 wchodzi 0
				; natomiast wskanik C=r16.7 (tu C=1)
	rol	r17		; r17 = FD hex
				; na pozycj bitu r17.0 wchodzi C=r16.7 (C=1)
				; wskanik V=0
				; wskanik C=1
				; nastpi nadmiar operacji w kodzie NB,
				; po wykonaniu operacji rejestr
				; r17:r16 = FDB8 hex
				;		= -584 dec (w kodzie U2)
				; 		= 64952 dec (w kodzie NB).
;*******
	ldi	r16,0xFF	; r16 = FF hex
	ldi	r17,0xFF	; r17 = FF hex
				; rejestr r17:r16 = FFFF hex
				;		= -1 dec (w kodzie U2)
				; 		= 65535 dec (w kodzie NB)
	lsl	r16		; r16 = FE hex
				; na pozycj bitu r16.0 wchodzi 0
				; natomiast wskanik C=r16.7
	rol	r17		; r17 = FF hex
				; na pozycj bitu r17.0 wchodzi C=r16.7
				; wskanik V=0
				; wskanik C=1
				; nastpi nadmiar operacji w kodzie NB,
				; po wykonaniu operacji rejestr
				; r17:r16 = FFFE hex
				;		= -2 dec (w kodzie U2)
				; 		= 65534 dec (w kodzie NB).
;*******
	ldi	r16,0x80	; r16 = 80 hex
	ldi	r17,0x80	; r17 = 80 hex
				; rejestr r17:r16 = 8080 hex
				;		= -32640 dec (w kodzie U2)
				; 		= 32896 dec (w kodzie NB)
	lsl	r16		; po operacji r16 = 00 hex
				; na pozycj bitu r16.0 wchodzi 0
				; natomiast wskanik C=r16.7 (tu C=1)
	rol	r17		; po operacji r17 = 01 hex
				; na pozycj bitu r17.0 wchodzi C=r16.7 (C=1)
				; wskanik V=1
				; wskanik C=1
				; nastpi nadmiar operacji w kodzie NB,
				; nastpi nadmiar operacji w kodzie U2,
				; po wykonaniu operacji rejestr
				; r17:r16 = 0100 hex
				;		= 256 dec (w kodzie U2)
				; 		= 256 dec (w kodzie NB).
	ret			;
;-----------------------------------------------------------------------------
Negacje:			;
	ldi	r16 , 0x05	;
	ldi	r17 , 0x00	; para rejestrw r17:r16 zawiera liczb
				; 0005 hex = 5 dec (U2)
	com	r16		; negacja wszystkich bitw rejestru r16
				; (po tej operacji r16=fa hex)
	com	r17		; negacja wszystkich bitw rejestru r17
				; (po tej operacji r17=ff hex)
	ldi	r18,1		;
	add	r16,r18		; po operacji r16=FB hex wskanik C=0
	ldi	r18,0		; zamiast instrukcji ldi r18,0 (zalecane
				; rozwizanie) mona uy instrukcji clr
				; r18 (koszt jest dokadnie ten sam),
				; rnica polega na tym, e instrukcja
				; clr modyfikuje wskaniki w rejestrze
				; SREG, a instrukcja ldi nie, co w
				; pewnych warunkach moe mie istotne
				; znaczenie (w tym konkretnym przykadzie
				; istotny jest wskanik C, a ten nie jest
				; modyfikowany przez instrukcj clr)
	adc	r17,r18		; powyszy cig instrukcji zwiksza
				; zawarto pary rejestrw r17:r16 o
				; jeden (po tej operacji r17:r16=FFFB hex
				;  jest to liczba (5) zapisana
				; w kodzie U2).
;*******
	ldi	r24 , 0x00	; r24=00 hex
	ldi	r25 , 0x01	; r25=01 hex:  r25:r24=0100 hex = 256 dec
	com	r24		; r24=FF hex
	com	r25		; r25=FE hex
	adiw	r24,1		; r25=FF hex i r24=00 hex
				; r25:r24=FF00 hex = -256 dec
;*******
	ldi	r16 , 0xff	;
	ldi	r17 , 0x01	; para rej. r17:r16=01FF hex =511 dec
	com	r16		; r16=00 hex
	com	r17		; r17=FE hex
	inc	r16		; r16=01hex
				; instrukcji inc nie mona uy poniewa
				; nie modyfikuje wskanika C, a ostatnia
				; zmiana tego wskanika w wyniku
				; dziaania instrukcji com daje C=1
	ldi	r18,0		;
	adc	r17,r18		; dodawanie daje wynik:
				; r17:r16=FF01 hex = -255 dec
				; ktry jest niepoprawny.
;*******
	ldi	r16 , 0x00	;
	ldi	r17 , 0x01	; para rej. r17:r16=0100 hex =256 dec
	com	r16		; r16=FF hex
	com	r17		; r17=FE hex
	inc	r16		; r16=00hex C=1
	ldi	r18,0		;
	adc	r17,r18		; dodawanie daje wynik:
				; r17:r16=FF00 hex = -256 dec
				; ktry jest w tym przypadku poprawny.
;*******
	ldi	r16,0xFB	; wpis do r16 liczby FB hex = -5 dec (U2)
	mov	r17,r16		;
	rol	r17		; wydzielenie bitu znaku do wskanika C
				; (C=r17.7=r16.7), tu C=1
	clr	r17		; zerowanie r17
	sbci	r17,0		; operacja odjcia od zawartoci rejestru r17
				; staej o wartoci zero z uwzgldnieniem
				; wskanika C, rejestr r17 zawiera zero
				; (instrukcja: clr r17) jeeli wskanik C=0,
				; to realizowana jest operacja
				; r17=0(r17)  0(odejmowana staa)  0
				; (wskanik C) co daje w wyniku 0 (wszystkie
				; bity = 0)
				; jeeli wskanik C=1, to realizowana jest
				; operacja :
				; r17=0(r17)  0(odejmowana staa)  1
				; (wskanik C) co daje w wyniku -1
				; (FF hex  wszystkie bity = 1)
				; cakowity wynik r17:r16= FFFB hex = -5 (U2)
				; zapisany na 16 bitach
	ret			;
;-----------------------------------------------------------------------------
Dodawanie :			;
	ldi	r16 , 0x0f	; wpis do rejestru r16 staej o wartoci
				; 0f hex
	ldi	r17 , 0xf0	; wpis do rejestru r17 staej o wartoci
				; f0 hex
	add	r16 , r17	; dodanie zawartoci rejestrw, w wyniku
				; uzyskuje si: r16 = ff hex
				; wskanik C=0 (nie nastpio
				; przeniesienie)
	ldi	r17 , 2		; wpis do rejestru r17 staej o
				; wartoci 2
	add	r16 , r17	; dodanie zawartoci rejestrw, w wyniku
				; uzyskuje si: r16 = 01 hex
				; wskanik C=1 (nastpio przeniesienie)
;*******
	ldi	r16 , 0xf0	;
	ldi	r17 , 0x0f	; uzyskanie jednego argumentu
				; R17:R16=0FF0 hex = 4080 dec (NB)
	ldi	r18 , 0x54	;
	ldi	r19 , 0xa5	; uzyskanie drugiego argumentu
				; R19:R18=a554 hex = 42324 dec (NB)
	add	r16 , r18	; dodanie czci modszych daje w wyniku
				; liczb 144 hex, co oznacza, e w
				; rejestrze R16 bdzie warto 44 hex i
				; wskanik C przyjmie warto 1
				; (nastpio przeniesienie w wyniku
				; dodawania)
	adc	r17 , r19	; dodanie czci starszych daje w wyniku
				; liczb B5 hex
				; (0F hex + A5 hex = B4 hex oraz dodanie
				; 1 wynikajcej z przeniesienia z
				; poprzedniego dodawania daje wynik B5
				; hex). Wynik cakowity :
				; r17:r16=B544 hex  =46404 dec (NB)
;*******
	ldi	r16 , 0xf0	; uzyskanie jednego argumentu
				; R17:R16=0FF0 hex
	ldi	r17 , 0x0f	; dziesitnie R17:R16=4080 dec(U2)
	ldi	r18 , 0x54	; uzyskanie drugiego argumentu
				; R19:R18=a554 hex
	ldi	r19 , 0xa5	; dziesitnie R19:R18 = -23212 dec (U2)
	add	r16 , r18	; dodanie czci modszych
	adc	r17 , r19	; dodanie czci starszych
				; wynik cakowity r17:r16=B544 hex
				; dziesitnie R17:R16 = -19132 (U2)
				; w istocie: 4080 + ( -23212 ) = -19132
	ret			;
;-----------------------------------------------------------------------------
ClearRAM :					;PROCEDURE ClearRAM ;
;*********					;BEGIN (* ClearRAM *)
	ldz	RAMEND-1			; Z := ADR ( RAMEND ) - 1 ;
	clr	acc				;
CleRA_0	:					; LOOP
	st	-z,acc				;  Z := Z - 1 ;
						;  Z ^ := 0 ;
	cpi	zh,0				;  IF Z = 0x60 THEN
	brne	CleRA_2				;
	cpi	zl,0x60				;
	brne	CleRA_2				;
	rjmp	CleRA_1				;   EXIT ;
CleRA_2	:					;  END (* IF *) ;
	rjmp	CleRA_0				;
CleRA_1	:					; END (* LOOP *) ;
	ret					;EBD (* ClearRAM *) ;
;-----------------------------------------------------------------------------
ClearRegs :					;PROCEDURE ClearRegs ;
;**********					;BEGIN (* ClearRegs *)
	clr	R0				;
	ldz	0x1D				;
ClrR_0	:					;
	st	Z,R0				;
	subi	zl,0x01				;
	sbci	zh,0x00				;
	brne	ClrR_0				;
	ret					;END (* ClearRegs *) ;
;-----------------------------------------------------------------------------
ResetProcessor	:				;
	ldi	acc,HIGH(RAMEND)		;
	out	SPH,acc				;
	ldi	acc,LOW(RAMEND)			;
	out	SPL,acc				;
						;BEGIN (* Main *)
	rcall	ClearRAM			; ClearRAM ( ) ;
	rcall	ClearRegs			; ClearRegs ( ) ;
;----------
	rcall	Dodawanie			;
	rcall	Negacje				;
	rcall	MnozeniePrzez2			;
	rcall	DzieleniePrzez2			;
	rcall	DzieleniePrzez10		;
	rcall	Relacje				;
	rcall	RelacjeU2			;
	rcall	Relacje16			;
	rcall	Relacje16U2			;
halt:	rjmp	halt				;
						;END Main ;
;-----------------------------------------------------------------------------
.exit
