;
;*******************************************************
;*******************************************************
;**                                                   **
;**    Sztuka programowania mikrokontrolerow AVR      **
;**                                                   **
;**       Prezentacje i ilustracje algorytmow         **
;**                                                   **
;**       Andrzej Pawluczuk                           **
;**                                                   **
;**         Mikrokontroler: ATMEGA8515                **
;**                Bialystok, 2006                    **
;**                                                   **
;*******************************************************
;*******************************************************
;
;*******************************************************
.include "m8515def.inc"
;*******************************************************
	.list
	.listmac
;-----------------------------------------------------------------------------
.macro	ldz
	ldi	zl,low(@0)
	ldi	zh,high(@0)
.endm
;-----------------------------------------------------------------------------
.def acc		= r16
.def acc2		= r17
.def param		= r18
;-----------------------------------------------------------------------------
		.dseg
;*******************************************************
;*******************************************************
;**                                                   **
;**                  DATA  SEGMENT                    **
;**                                                   **
;*******************************************************
;*******************************************************
;-----------------------------------------------------------------------------
		.cseg
;*******************************************************
;*******************************************************
;**                                                   **
;**                  CODE  SEGMENT                    **
;**                                                   **
;*******************************************************
;*******************************************************
	.org	0				;
	rjmp	ResetProcessor			;
;-----------------------------------------------------------------------------
.def Arg1L	= r2
.def Arg1H	= r3
.def Arg2L	= r4
.def Arg2H	= r5
.def ResultLL	= r6
.def ResultLH	= r7
.def ResultHL	= r8
.def ResultHH 	= r9
.def DivLoopCnt	= r10
;-----------------------------------------------------------------------------
HMultArg1AndArg2:		;PROCEDURE HMultArg1AndArg2 ;
;*****************		; dane do procedury umieci w rejestrach
				; Arg1 = Arg1H:Arg1L
				; Arg2 = Arg2H:Arg2L
				; s sowami (po 2 bajty)
				; Result := Arg1 * Arg2 ;
				; Result=ResultHH:ResultHL:ResultLH:ResultLL
				; jest dugim sowem (4 bajty)
	clr	acc		; wstpne wyzerowanie potrzebnych rejestrw
	clr	ResultHL	;
	clr	ResultHH	;
	mul	Arg1L,Arg2L	; pomnoenie najmodszych czci liczb
	mov	ResultLH,R1	; przepisanie ich do miejsca docelowego
	mov	ResultLL,R0	; (wynik instrukcji mul zawarty jest w
				; R1:R0)
	mul	Arg1H,Arg2L	; wymnoenie kolejnych fragmentw
				; (wchodzcych w skad
				; czci przesunitej o 8 bitw)
	add	ResultLH,R0	; dosumowanie do odpowiednich czci
				; wyniku
	adc	ResultHL,R1	;
	adc	ResultHH,acc	; poniewa moe wystpi przeniesienie z
				; poprzedniego dosumowania, naley je
				; uwzgldni dodajc rejestr z
				; zawartoci zerow (wskanik C sam si
				; doda)
	mul	Arg1L,Arg2H	; wymnoenie kolejnych fragmentw
				; (wchodzcych w skad
				; czci przesunitej o 8 bitw)
	add	ResultLH,R0	; analogicznie jak wyej dosumowanie
				; kolejnych
	adc	ResultHL,R1	; fragmentw wyniku
	adc	ResultHH,acc	;
	mul	Arg1H,Arg2H 	; wymnoenie najstarszych czci wyniku
				; (wchodzcych
	add	ResultHL,R0	; w skad wyniku z przesuniciem 16
				; bitw)
	adc	ResultHH,R1	;
	ret			;END (* HMultArg1AndArg2 *) ;
;-----------------------------------------------------------------------------
HMultArg1AndArg2U2:		;PROCEDURE HMultArg1AndArg2U2 ;
;*****************		; dane do procedury umieci w rejestrach
				; Arg1 = Arg1H:Arg1L
				; Arg2 = Arg2H:Arg2L
				; s sowami (po 2 bajty)
				; Result := Arg1 * Arg2 ;
				; Result=ResultHH:ResultHL:ResultLH:ResultLL
				; jest dugim sowem (4 bajty)
				; acc2 bdzie zawiera informacj o znaku
				; wyniku
	clr	ResultHL	; wstpne wyzerowanie potrzebnych
				; rejestrw
	clr	ResultHH	;
	clr	acc2		; zaoenie, ze wynik jest dodatni
				; (acc2=0)
	mov	acc, Arg1H	; zbadanie znaku pierwszego czynnika
	or	acc,acc		;
	brpl	HMul_0		; jeeli N=0 (Arg1>=0), to przechodzimy
				; do wskazanej etykiety
	com	acc2		; okrelenie, e wynik bdzie ujemny
				; (acc2#0)
	com	Arg1H		; Arg1 := - Arg1 (zmiana znaku czynnika
				; Arg1)
	com	Arg1L		; negacja obu rejestrw i zwikszenie
				; zawartoci o 1
	ldi	acc,1		;
	add	Arg1L,acc	;
	ldi	acc,0		;
	adc	Arg1H,acc	;
HMul_0:				;
	mov	acc, Arg2H	; zbadanie znaku pierwszego czynnika
	or	acc,acc		;
	brpl	HMul_1		; jeeli N=0 (Arg2>=0), to przechodzimy
				; do wskazanej etykiety
	com	acc2		; okrelenie, e wynik bdzie ewentualnie
				; ujemny
	com	Arg2H		; Arg2 := - Arg2 (zmiana znaku czynnika
				; Arg2)
	com	Arg2L		; negacja obu rejestrw i zwikszenie
				; zawartoci o 1
	ldi	acc,1		;
	add	Arg2L,acc	;
	ldi	acc,0		;
	adc	Arg2H,acc	;
HMul_1:				;
	clr	acc		;
	mul	Arg1L,Arg2L	; pomnoenie najmodszych czci liczb
	mov	ResultLH,R1	; przepisanie ich do miejsca docelowego
	mov	ResultLL,R0	; (wynik instrukcji mul zawarty jest w
				; R1:R0)
	mul	Arg1H,Arg2L	; wymnoenie kolejnych fragmentw
				; (wchodzcych w skad czci
				; przesunitej o 8 bitw)
	add	ResultLH,R0	; dosumowanie do odpowiednich czci
				; wyniku
	adc	ResultHL,R1	;
	adc	ResultHH,acc	; poniewa moe wystpi przeniesienie z
				; poprzedniego dosumowania, naley je
				; uwzgldni dodajc rejestr z
				; zawartoci zerow (wskanik C sam si
				; doda)
	mul	Arg1L,Arg2H	; wymnoenie kolejnych fragmentw
				; (wchodzcych w skad
				; czci przesunitej o 8 bitw)
	add	ResultLH,R0	; analogicznie jak wyej dosumowanie
				; kolejnych
	adc	ResultHL,R1	; fragmentw wyniku
	adc	ResultHH,acc	;
	mul	Arg1H,Arg2H	; wymnoenie najstarszych czci wyniku
				; (wchodzcych
	add	ResultHL,R0	; w skad wyniku z przesuniciem 16
				; bitw)
	adc	ResultHH,R1	;
	or	acc2,acc2	; jeeli kocowy wynik ma by ujemny
				; (acc2#0)
	breq	HMul_2		;
	com	ResultLL	; to naley zmieni znak wyniku,
				; Result := - Result
	com	ResultLH	; negacja logiczna wszystkich czci
				; wyniku
	com	ResultHL	;
	com	ResultHH	;
	ldi	acc,1		; zwikszenie wyniku o jeden
	add	ResultLL,acc	;
	ldi	acc,0		;
	adc	ResultLH,acc	;
	adc	ResultHL,acc	;
	adc	ResultHH,acc	;
HMul_2:				;
	ret			;END (* HMultArg1AndArg2U2 *) ;
;-----------------------------------------------------------------------------
MultArg1AndArg2 :		;PROCEDURE MultArg1AndArg2 ( ) ;
;***************		; Arg1 = Arg1H:Arg1L
				; Arg2 = Arg2H:Arg2L
				; s sowami (po 2 bajty)
				; Result := Arg1 * Arg2 ;
				; Result=ResultHH:ResultHL:ResultLH:ResultLL
				; jest dugim sowem (4 bajty)
	clr	ResultLL	; wstpne wyzerowanie rejestru
				; wynikowego
	clr	ResultLH	;
	clr	ResultHL	;
	clr	ResultHH	;
	ldi	acc , 16	; okrelenie licznika ptli
	mov	DivLoopCnt,acc	;
Mul_0	:			;
	lsl	ResultLL	; pomnoenie zawartoci rejestru
	rol	ResultLH	; wynikowego przez 2 
	rol	ResultHL	;(przesunicie o 1 bit w lewo)
	rol	ResultHH	;
	lsl	Arg2L		; wydzielenie do wskanika C
				; najstarszego bitu
	rol	Arg2H		;
	brcc	Mul_1		; badanie wskanika C
	add	ResultLL,Arg1L	; jeeli wskanik jest ustawiony, to
				; do rejestru
	adc	ResultLH,Arg1H	; wynikowego naley doda zawarto
				; rejestru
	ldi	acc,0		; bdcego argumentem
					;(dodawanie 2 bajtw
	adc	ResultHL,acc	; do wyniku bdcego na 4 bajtach)
	adc	ResultHH,acc	;
Mul_1	:			;
	dec	DivLoopCnt	; zmniejszenie o 1 licznika cykli i
	brne	Mul_0		; ewentualny powrt do ptli
	ret			;END MultArg1AndArg2 ;
;-----------------------------------------------------------------------------
MultArg1AndArg2U2 :		;PROCEDURE MultArg1AndArg2U2 ( ) ;
;***************		; Arg1 = Arg1H:Arg1L
				; Arg2 = Arg2H:Arg2L
				; s sowami (po 2 bajty)
				; Result := Arg1 * Arg2 ;
				; Result=ResultHH:ResultHL:ResultLH:ResultLL
				; jest dugim sowem (4 bajty)
				;BEGIN (* MultArg1AndArg2U2 *)
	clr	acc		;
	mov	ResultLL,acc	;
	mov	ResultLH,acc	;
	mov	ResultHL,acc	;
	mov	ResultHH,acc	;
	ldi	acc,15		;
	mov	DivLoopCnt,acc	;
	lsl	Arg2L		;
	rol	Arg2H		;
	brcc	MultU2_3	;
	mov	ResultLL,Arg1L	;
	mov	ResultLH,Arg1H	;
	com	ResultLL	;
	com	ResultLH	;
	ldi	acc,1		;
	add	ResultLL,acc	;
	ldi	acc,0		;
	adc	ResultLH,acc	;
	mov	acc,ResultLH	;
	rol	acc		;
	rol	ResultHL	;
MultU2_3:			;
MultU2_0:			;
	lsl	ResultLL	;
	rol	ResultLH	;
	rol	ResultHL	;
	rol	ResultHH	;
	lsl	Arg2L		;
	rol	Arg2H		;
	brcc	MultU2_1	;
	mov	acc,Arg1H	;
	rol	acc		;
	ldi	acc,0		;
	sbci	acc,0		;
	add	ResultLL,Arg1L	;
	adc	ResultLH,Arg1H	;
	adc	ResultHL,acc	;
	adc	ResultHH,acc	;
MultU2_1:			;
	dec	DivLoopCnt	;
	brne	MultU2_0	;
	ret			;END (* MultArg1AndArg2U2 *) ;
;-----------------------------------------------------------------------------
ClearRAM :				;PROCEDURE ClearRAM ;
;*********				;BEGIN (* ClearRAM *)
	ldz	RAMEND-1		; Z := ADR ( RAMEND ) - 1 ;
	clr	acc			;
CleRA_0	:				; LOOP
	st	-z,acc			;  Z := Z - 1 ;
					;  Z ^ := 0 ;
	cpi	zh,0			;  IF Z = 0x60 THEN
	brne	CleRA_2			;
	cpi	zl,0x60			;
	brne	CleRA_2			;
	rjmp	CleRA_1			;   EXIT ;
CleRA_2	:				;  END (* IF *) ;
	rjmp	CleRA_0			;
CleRA_1	:				; END (* LOOP *) ;
	ret				;EBD (* ClearRAM *) ;
;-----------------------------------------------------------------------------
ClearRegs :				;PROCEDURE ClearRegs ;
;**********				;BEGIN (* ClearRegs *)
	clr	R0			;
	ldz	0x1D			;
ClrR_0	:				;
	st	Z,R0			;
	subi	zl,0x01			;
	sbci	zh,0x00			;
	brne	ClrR_0			;
	ret				;END (* ClearRegs *) ;
;-----------------------------------------------------------------------------
ResetProcessor	:			;
	ldi	acc,HIGH(RAMEND)	;
	out	SPH,acc			;
	ldi	acc,LOW(RAMEND)		;
	out	SPL,acc			;
					;BEGIN (* Main *)
	rcall	ClearRAM		; ClearRAM ( ) ;
	rcall	ClearRegs		; ClearRegs ( ) ;
;*******
	ldi	acc , 0xFC		; przygotowanie parametrw wywoania
	mov	Arg1H , acc		;
	ldi	acc , 0x49		;
	mov	Arg1L , acc		; Arg1 = FC49 hex = -951 dec (U2)
	ldi	acc , 0x02		; przygotowanie parametrw wywoania
	mov	Arg2H , acc		;
	ldi	acc , 0xF1		;
	mov	Arg2L , acc		; Arg2 = 2F1 hex = 753 dec (u2)
	rcall	MultArg1AndArg2U2	; wywoanie procedury (mnoenie bez
					; znaku) w wyniku dziaania procedury w
					; czwrce rejestrw
					; Result =
					; ResultHH:ResultHL:ResultLH:ResultLL
					; wynik: Result = FFF512B9 hex
					;		= -716103 dec
					; w istocie (-951) * 753 = -716103
	ldi	acc , 0xFF		; przygotowanie parametrw wywoania
	mov	Arg1H , acc		;
	ldi	acc , 0xFF		;
	mov	Arg1L , acc		; Arg1 = FFFF hex = -1 dec (U2)
	ldi	acc , 0xFF		; przygotowanie parametrw wywoania
	mov	Arg2H , acc		;
	ldi	acc , 0xFF		;
	mov	Arg2L , acc		; Arg2 = FFFF hex = -1 dec (u2)
	rcall	MultArg1AndArg2U2	; wywoanie procedury (mnoenie bez
					; znaku) w wyniku dziaania procedury w
					; czwrce rejestrw
					; Result =
					; ResultHH:ResultHL:ResultLH:ResultLL
					; wynik: Result = 00000001 hex
					;		= 1 dec
					; w istocie (-1) * (-1) = 1
;*******
	ldi	acc , HIGH(102)		; przygotowanie parametrw wywoania
	mov	Arg1H , acc		;
	ldi	acc , LOW(102)		;
	mov	Arg1L , acc		; Arg1 = 102 dec = 66 hex
	ldi	acc , HIGH ( 2354 )	;
	mov	Arg2H , acc		;
	ldi	acc , LOW ( 2354 )	;
	mov	Arg2L , acc		; Arg2 = 2354 dec = 932 hex
	rcall	HmultArg1AndArg2	; wywoanie procedury (mnoenie
					; bez znaku) w wyniku dziaania
					; procedury w czwrce rejestrw
					; Result =
					; ResultHH:ResultHL:ResultLH:ResultLL
					; jest wynik: Result = 0003A9EC hex
					;		     = 240108 dec
					; w istocie 102 * 2354 = 240108
;*******
	ldi	acc , 0xFF		; przygotowanie parametrw wywoania
	mov	Arg1H , acc		;
	ldi	acc , 0xFF		;
	mov	Arg1L , acc		; Arg1 = FFFF hex = 65535 dec
	ldi	acc , 0xFF		; przygotowanie parametrw wywoania
	mov	Arg2H , acc		;
	ldi	acc , 0xFF		;
	mov	Arg2L , acc		; Arg2 = FFFF hex = 65535 dec
	rcall	HmultArg1AndArg2	; wywoanie procedury (mnoenie bez
					; znaku) w wyniku dziaania procedury w
					; czwrce rejestrw
					; Result =
					; ResultHH:ResultHL:ResultLH:ResultLL
					; wynik: Result = FFFE0001 hex
					;	        = 4294836225 dec
					; w istocie 65535 * 65535 = 4294836225
;*******
	ldi	acc , 0xFC		; przygotowanie parametrw wywoania
	mov	Arg1H , acc		;
	ldi	acc , 0x49		;
	mov	Arg1L , acc		; Arg1 = FC49 hex = -951 dec (U2)
	ldi	acc , 0x02		; przygotowanie parametrw wywoania
	mov	Arg2H , acc		;
	ldi	acc , 0xF1		;
	mov	Arg2L , acc		; Arg2 = 2F1 hex = 753 dec (u2)
	rcall	HMultArg1AndArg2U2	; wywoanie procedury (mnoenie ze
					; znakiem) w wyniku dziaania procedury w
					; czwrce rejestrw
					; Result =
					; ResultHH:ResultHL:ResultLH:ResultLL
					; wynik: Result = FFF512B9 hex
					;		= -716103 dec
					; w istocie (-951) * 753 = -716103
;*******
	ldi	acc , HIGH(102)	; przygotowanie parametrw wywoania
	mov	Arg1H , acc		;
	ldi	acc , LOW(102)		;
	mov	Arg1L , acc		; Arg1 = 102 dec = 66 hex
	ldi	acc , HIGH ( 2354 )	;
	mov	Arg2H , acc		;
	ldi	acc , LOW ( 2354 )	;
	mov	Arg2L , acc		; Arg2 = 2354 dec = 932 hex
	rcall	MultArg1AndArg2		; wywoanie procedury (mnoenie
					; bez znaku) w wyniku dziaania
					; procedury w czwrce rejestrw
					; Result =
					; ResultHH:ResultHL:ResultLH:ResultLL
					; jest wynik: Result = 0003A9EC hex
					;		     = 240108 dec
					; w istocie 102 * 2354 = 240108
;*******
	ldi	acc , 0xFF		; przygotowanie parametrw wywoania
	mov	Arg1H , acc		;
	ldi	acc , 0xFF		;
	mov	Arg1L , acc		; Arg1 = FFFF hex = 65535 dec
	ldi	acc , 0xFF		; przygotowanie parametrw wywoania
	mov	Arg2H , acc		;
	ldi	acc , 0xFF		;
	mov	Arg2L , acc		; Arg2 = FFFF hex = 65535 dec
	rcall	MultArg1AndArg2		; wywoanie procedury (mnoenie
					; znaku) w wyniku dziaania procedury w
					; czwrce rejestrw
					; Result =
					; ResultHH:ResultHL:ResultLH:ResultLL
					; wynik: Result = FFFE0001 hex
					;		= 4294836225 dec
					; w istocie 65535 * 65535 = 4294836225
halt:	rjmp	halt			;
.exit
